#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define pb push_back
#define mp make_pair
#define ff first
#define ss second
// #define MAX 100005
#define MAX 10000005
#define MOD 1000000007
typedef vector<int> vi;
typedef pair<int, int> ip;

// Program assumes that maximum value of n is 10^7
vector<int> children[MAX],vd[MAX];
int depth[MAX],parent[MAX],temp[MAX],vis[MAX];
int max_depth = 0;
bool dead[MAX];
ll have[MAX],cap[MAX];
queue<int> q;

// int total = 0;

// DFS to calculate depths
void initdfs(int u){
	max_depth = max(max_depth, depth[u]);
	vd[depth[u]].pb(u);
	for(int v: children[u]){
		depth[v] = 1+depth[u];
		initdfs(v);
	}
}

/*
 For each depth, calculate contribution of vertices at that depth to the root. 
 Meanwhile, also reduce the graph made by above vertices by compressing straight-line paths.
*/ 
void compute(int d){
	for(int u: vd[d])
		q.push(u);

	int cnt = 0;
	while(!q.empty()){
		int u = q.front();
		q.pop();
		if(u == 1)
		    continue;
		if((have[u] <= cap[u]) && !dead[parent[u]]){
			have[parent[u]] += have[u];
			++vis[parent[u]];	
			if(vis[parent[u]] == 1){
				q.push(parent[u]);	
				temp[cnt++] = parent[u];
			}
		}
		else
			dead[u] = 1;
		have[u] = 0;
	}

	// total += cnt;

	for(int u: vd[d]){
		while(parent[u]!=1  && vis[parent[u]]==1){
			cap[u] = min(cap[u],cap[parent[u]]);
			dead[u] |= dead[parent[u]];
			parent[u] = parent[parent[u]];
		}
	}

	for(int i=0;i<cnt;i++)
		vis[temp[i]] = 0;
}

int main(){
	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
	
	int n;
	cin>>n;
	for(int i=2;i<=n;i++)
		cin>>have[i]>>cap[i];
	for(int i=2;i<=n;i++){
		cin>>parent[i];
		children[parent[i]].pb(i);
	}
	
	memset(vis,0,sizeof(vis));
	memset(dead,0,sizeof(dead));
	have[1] = 0;
	cap[1] = 1000000000000000000LL;
	depth[1] = 0;
	vis[1] = 1;
	initdfs(1);
	
	for(int d=1;d<=max_depth;d++)
		compute(d);

	// verify number of steps (should give WA if greater)
	// if(total > 3*n){
	// 	cout<<"-1\n";
	// 	return 0;
	// }

	cout<<have[1]<<"\n";
}
